#lang scheme

(require "board.ss"
         "play.ss")

(define (print-board str state)
  (newline)
  (let ([state (state->pos-list state)])
    (for ([row (in-range 25)])
      (for ([col (in-range 25)])
        (printf "~a"
                (or
                 (for/or ([pos (in-list state)]
                          [i (in-naturals)])
                   (and (= (car pos) row)
                        (= (cadr pos) col)
                        i))
                 (let ([c (board-ref row col)])
                   (cond
                     [(door? c) c]
                     [(room? c) c]
                     [(solid? c) '+]
                     [else '-])))))
      (newline)))
  (newline)
  (printf "~a\n" str))


(void
 (sync
  (play-all (lambda (str) (printf "~a\n" str))
            print-board)))
 